#version 330 core

in vec2 UV;
out vec4 fragColor;

uniform sampler2D textu;
uniform sampler2D tmask;
uniform float zoom;

void main() {
	vec2 r = UV - 0.5;
	float zb = sqrt(zoom);
	vec2 tUV = r * zb + 0.5;
    fragColor = texture(textu, UV) * texture(tmask, clamp(vec2(tUV.x, 1.-tUV.y), 0.0, 1.0));
}
